Index: squid/src/peer_select.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/peer_select.c,v
retrieving revision 1.3.6.8
retrieving revision 1.3.6.9
diff -u -r1.3.6.8 -r1.3.6.9
--- squid/src/peer_select.c	1 Jul 2007 05:44:24 -0000	1.3.6.8
+++ squid/src/peer_select.c	2 Jul 2007 07:37:01 -0000	1.3.6.9
@@ -1,6 +1,6 @@
 
 /*
- * $Id: peer_select.c,v 1.3.6.8 2007/07/01 05:44:24 amosjeffries Exp $
+ * $Id: peer_select.c,v 1.3.6.9 2007/07/02 07:37:01 amosjeffries Exp $
  *
  * DEBUG: section 44    Peer Selection Algorithm
  * AUTHOR: Duane Wessels
@@ -425,20 +425,10 @@
 	code = SOURCE_FASTEST;
     } else
 #endif
-    if ((ps->closest_parent_miss.ss_family == AF_INET6) && 
-	!IN6_IS_ADDR_UNSPECIFIED(&((struct sockaddr_in6 *)&ps->closest_parent_miss)->sin6_addr)) {
+    if (ps->closest_parent_miss.sin_addr.s_addr != any_addr.s_addr) {
 	p = whichPeer(&ps->closest_parent_miss);
 	code = CLOSEST_PARENT_MISS;
-    } else if ((ps->closest_parent_miss.ss_family == AF_INET) &&
-	(((struct sockaddr_in *)&ps->closest_parent_miss)->sin_addr.s_addr != any_addr.s_addr)) {
-	p = whichPeer(&ps->closest_parent_miss);
-	code = CLOSEST_PARENT_MISS;
-    } else if ((ps->first_parent_miss.ss_family == AF_INET6) && 
-	!IN6_IS_ADDR_UNSPECIFIED(&((struct sockaddr_in6 *)&ps->first_parent_miss)->sin6_addr)) {
-	p = whichPeer(&ps->first_parent_miss);
-	code = FIRST_PARENT_MISS;
-    } else if ((ps->first_parent_miss.ss_family == AF_INET) && 
-	(((struct sockaddr_in *)&ps->first_parent_miss)->sin_addr.s_addr != any_addr.s_addr)) {
+    } else if (ps->first_parent_miss.sin_addr.s_addr != any_addr.s_addr) {
 	p = whichPeer(&ps->first_parent_miss);
 	code = FIRST_PARENT_MISS;
     }
@@ -533,11 +523,6 @@
 {
     ps_state *psstate = data;
     StoreEntry *entry = psstate->entry;
-    if (!psstate->request) {
-	debug(44, 3) ("peerPingTimeout: null request\n");
-	peerSelectStateFree(psstate);
-	return;
-    }
     if (entry)
 	debug(44, 3) ("peerPingTimeout: '%s'\n", storeUrl(entry));
     if (!cbdataValid(psstate->callback_data)) {
@@ -580,21 +565,12 @@
     if (p->options.closest_only)
 	return;
     /* set FIRST_MISS if there is no CLOSEST parent */
-    if ((ps->closest_parent_miss.ss_family == AF_INET6) && 
-	!IN6_IS_ADDR_UNSPECIFIED(&((struct sockaddr_in6 *)&ps->closest_parent_miss)->sin6_addr)) 
-	return;
-    else if ((ps->closest_parent_miss.ss_family == AF_INET) &&
-	(((struct sockaddr_in *)&ps->closest_parent_miss)->sin_addr.s_addr != any_addr.s_addr)) 
+    if (ps->closest_parent_miss.sin_addr.s_addr != any_addr.s_addr)
 	return;
     rtt = tvSubMsec(ps->ping.start, current_time) / p->weight;
-    if ((
-    ((ps->first_parent_miss.ss_family == AF_INET6) && 
-	IN6_IS_ADDR_UNSPECIFIED(&((struct sockaddr_in6 *)&ps->first_parent_miss)->sin6_addr)) ||
-    ((ps->first_parent_miss.ss_family == AF_INET) && 
-	(((struct sockaddr_in *)&ps->first_parent_miss)->sin_addr.s_addr != any_addr.s_addr)) 
-	)
-	|| rtt < ps->ping.w_rtt) {
-	xmemcpy(&ps->first_parent_miss, &p->in_addr, sizeof(&p->in_addr));
+    if (ps->first_parent_miss.sin_addr.s_addr == any_addr.s_addr ||
+	rtt < ps->ping.w_rtt) {
+	ps->first_parent_miss = p->in_addr;
 	ps->ping.w_rtt = rtt;
     }
 }
Index: squid/src/peer_sourcehash.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/peer_sourcehash.c,v
retrieving revision 1.3.42.3
retrieving revision 1.3.42.4
diff -u -r1.3.42.3 -r1.3.42.4
--- squid/src/peer_sourcehash.c	1 Jul 2007 05:44:24 -0000	1.3.42.3
+++ squid/src/peer_sourcehash.c	2 Jul 2007 07:37:01 -0000	1.3.42.4
@@ -1,6 +1,6 @@
 
 /*
- * $Id: peer_sourcehash.c,v 1.3.42.3 2007/07/01 05:44:24 amosjeffries Exp $
+ * $Id: peer_sourcehash.c,v 1.3.42.4 2007/07/02 07:37:01 amosjeffries Exp $
  *
  * DEBUG: section 44    Peer user hash based selection
  * AUTHOR: Henrik Nordstrom
@@ -136,7 +136,7 @@
     double high_score = 0;
     char *key = NULL;
 
-    key = sockaddr_ntoa(&request->client_addr);
+    key = inet_ntoa(request->client_addr);
 
     /* calculate hash key */
     debug(39, 2) ("peerSourceHashSelectParent: Calculating hash for %s\n", key);
Index: squid/src/protos.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/protos.h,v
retrieving revision 1.5.2.14
retrieving revision 1.5.2.15
diff -u -r1.5.2.14 -r1.5.2.15
--- squid/src/protos.h	1 Jul 2007 08:34:29 -0000	1.5.2.14
+++ squid/src/protos.h	2 Jul 2007 07:37:01 -0000	1.5.2.15
@@ -1,6 +1,6 @@
 
 /*
- * $Id: protos.h,v 1.5.2.14 2007/07/01 08:34:29 amosjeffries Exp $
+ * $Id: protos.h,v 1.5.2.15 2007/07/02 07:37:01 amosjeffries Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -109,7 +109,7 @@
 extern void parse_time_t(time_t * var);
 extern void parse_cachedir_options(SwapDir * sd, struct cache_dir_option *options, int reconfiguring);
 extern void dump_cachedir_options(StoreEntry * e, struct cache_dir_option *options, SwapDir * sd);
-extern void parse_sockaddr_storage_list_token(sockaddr_storage_list **, char *);
+extern void parse_sockaddr_in_list_token(sockaddr_in_list **, char *);
 
 
 /*
@@ -133,11 +133,11 @@
 extern int cbdataLocked(const void *p);
 
 extern void clientdbInit(void);
-extern void clientdbUpdate(struct sockaddr *, log_type, protocol_t, squid_off_t);
-extern int clientdbCutoffDenied(struct sockaddr *);
+extern void clientdbUpdate(struct in_addr, log_type, protocol_t, squid_off_t);
+extern int clientdbCutoffDenied(struct in_addr);
 extern void clientdbDump(StoreEntry *);
 extern void clientdbFreeMemory(void);
-extern int clientdbEstablished(struct sockaddr *, int);
+extern int clientdbEstablished(struct in_addr, int);
 
 extern char *clientConstructTraceEcho(clientHttpRequest *);
 extern int checkNegativeHit(StoreEntry *);
@@ -151,18 +151,18 @@
 extern int commSetNonBlocking(int fd);
 extern int commUnsetNonBlocking(int fd);
 extern void commSetCloseOnExec(int fd);
-extern int comm_accept(int fd, struct sockaddr *, struct sockaddr *);
+extern int comm_accept(int fd, struct sockaddr_in *, struct sockaddr_in *);
 extern void comm_close(int fd);
 extern void comm_reset_close(int fd);
 #if LINGERING_CLOSE
 extern void comm_lingering_close(int fd);
 #endif
-extern void commConnectStart(int fd, const char *, u_short, CNCB *, void *, struct sockaddr *addr);
-extern int comm_connect_addr(int sock, const struct sockaddr *);
+extern void commConnectStart(int fd, const char *, u_short, CNCB *, void *, struct in_addr *addr);
+extern int comm_connect_addr(int sock, const struct sockaddr_in *);
 extern void comm_init(void);
 extern int comm_listen(int sock);
-extern int comm_open(int, int, struct sockaddr *, int, const char *note);
-extern int comm_openex(int, int, struct sockaddr *, int, unsigned char TOS, const char *);
+extern int comm_open(int, int, struct in_addr, u_short port, int, const char *note);
+extern int comm_openex(int, int, struct in_addr, u_short, int, unsigned char TOS, const char *);
 extern u_short comm_local_port(int fd);
 
 extern void commDeferFD(int fd);
@@ -171,7 +171,7 @@
 extern void commRemoveSlow(int fd);
 extern void comm_add_close_handler(int fd, PF *, void *);
 extern void comm_remove_close_handler(int fd, PF *, void *);
-extern int comm_udp_sendto(int, const struct sockaddr *, int, const void *, int);
+extern int comm_udp_sendto(int, const struct sockaddr_in *, int, const void *, int);
 extern void comm_write(int fd,
     const char *buf,
     int size,
@@ -251,7 +251,7 @@
 extern void idnsInit(void);
 extern void idnsShutdown(void);
 extern void idnsALookup(const char *, IDNSCB *, void *);
-extern void idnsPTRLookup(const struct sockaddr *, IDNSCB *, void *);
+extern void idnsPTRLookup(const struct in_addr, IDNSCB *, void *);
 
 extern void eventAdd(const char *name, EVH * func, void *arg, double when, int);
 extern void eventAddIsh(const char *name, EVH * func, void *arg, double delta_ish, int);
@@ -283,12 +283,12 @@
 extern void filemapFreeMemory(fileMap *);
 
 
-extern void fqdncache_nbgethostbyaddr(struct sockaddr *, FQDNH *, void *);
-extern const char *fqdncache_gethostbyaddr(struct sockaddr *, int flags);
+extern void fqdncache_nbgethostbyaddr(struct in_addr, FQDNH *, void *);
+extern const char *fqdncache_gethostbyaddr(struct in_addr, int flags);
 extern void fqdncache_init(void);
 extern void fqdnStats(StoreEntry *);
 extern void fqdncacheReleaseInvalid(const char *);
-extern const char *fqdnFromAddr(struct sockaddr *);
+extern const char *fqdnFromAddr(struct in_addr);
 extern int fqdncacheQueueDrain(void);
 extern void fqdncacheFreeMemory(void);
 extern void fqdncache_restart(void);
@@ -535,7 +535,7 @@
     const char *url,
     int reqnum,
     int pad);
-extern int icpUdpSend(int, const struct sockaddr *, icp_common_t *, log_type, int);
+extern int icpUdpSend(int, const struct sockaddr_in *, icp_common_t *, log_type, int);
 extern PF icpHandleUdp;
 extern PF icpUdpSendQueue;
 extern PF httpAccept;
@@ -579,7 +579,7 @@
 extern void wccp2ConnectionClose(void);
 #endif /* USE_WCCPv2 */
 
-extern void icpHandleIcpV3(int, struct sockaddr *, char *, int);
+extern void icpHandleIcpV3(int, struct sockaddr_in, char *, int);
 extern int icpCheckUdpHit(StoreEntry *, request_t * request);
 extern void icpConnectionsOpen(void);
 extern void icpConnectionShutdown(void);
@@ -597,8 +597,8 @@
 extern void ipcache_init(void);
 extern void stat_ipcache_get(StoreEntry *);
 extern void ipcacheCycleAddr(const char *name, ipcache_addrs *);
-extern void ipcacheMarkBadAddr(const char *name, struct sockaddr *);
-extern void ipcacheMarkGoodAddr(const char *name, struct sockaddr *);
+extern void ipcacheMarkBadAddr(const char *name, struct in_addr);
+extern void ipcacheMarkGoodAddr(const char *name, struct in_addr);
 extern void ipcacheFreeMemory(void);
 extern ipcache_addrs *ipcacheCheckNumeric(const char *name);
 extern void ipcache_restart(void);
@@ -665,7 +665,7 @@
     int *exprep,
     int *timeout);
 extern void neighborAddAcl(const char *, const char *);
-extern void neighborsUdpAck(const cache_key *, icp_common_t *, const struct sockaddr *);
+extern void neighborsUdpAck(const cache_key *, icp_common_t *, const struct sockaddr_in *);
 extern void neighborAdd(const char *, const char *, int, int, int, int, int);
 extern void neighbors_init(void);
 extern peer *peerFindByName(const char *);
@@ -686,22 +686,22 @@
 extern void peerConnectSucceded(peer *);
 extern void dump_peer_options(StoreEntry *, peer *);
 extern int peerHTTPOkay(const peer *, request_t *);
-extern peer *whichPeer(const struct sockaddr *from);
+extern peer *whichPeer(const struct sockaddr_in *from);
 #if USE_HTCP
-extern void neighborsHtcpReply(const cache_key *, htcpReplyData *, const struct sockaddr *);
+extern void neighborsHtcpReply(const cache_key *, htcpReplyData *, const struct sockaddr_in *);
 #endif
 extern void peerAddFwdServer(FwdServer ** FS, peer * p, hier_code code);
 extern int peerAllowedToUse(const peer *, request_t *);
 
 extern void netdbInit(void);
-extern void netdbHandlePingReply(const struct sockaddr *from, int hops, int rtt);
+extern void netdbHandlePingReply(const struct sockaddr_in *from, int hops, int rtt);
 extern void netdbPingSite(const char *hostname);
-extern int netdbHops(struct sockaddr *);
+extern int netdbHops(struct in_addr);
 extern void netdbFreeMemory(void);
 extern int netdbHostHops(const char *host);
 extern int netdbHostRtt(const char *host);
 extern void netdbUpdatePeer(request_t *, peer * e, int rtt, int hops);
-extern void netdbDeleteAddrNetwork(struct sockaddr *addr);
+extern void netdbDeleteAddrNetwork(struct in_addr addr);
 extern void netdbBinaryExchange(StoreEntry *);
 extern EVH netdbExchangeStart;
 extern void netdbExchangeUpdatePeer(struct in_addr, peer *, double, double);
@@ -736,7 +736,7 @@
 extern void fwdLogRotate(void);
 extern void fwdStatus(FwdState *, http_status);
 #endif
-struct sockaddr_storage *getOutgoingAddr(request_t * request);
+struct in_addr getOutgoingAddr(request_t * request);
 unsigned long getOutgoingTOS(request_t * request);
 
 extern void urnStart(request_t *, StoreEntry *);
@@ -763,14 +763,14 @@
 extern void authenticateShutdown(void);
 extern void authenticateFixHeader(HttpReply *, auth_user_request_t *, request_t *, int, int);
 extern void authenticateAddTrailer(HttpReply *, auth_user_request_t *, request_t *, int);
-extern auth_acl_t authenticateTryToAuthenticateAndSetAuthUser(auth_user_request_t **, http_hdr_type, request_t *, ConnStateData *, struct sockaddr *);
+extern auth_acl_t authenticateTryToAuthenticateAndSetAuthUser(auth_user_request_t **, http_hdr_type, request_t *, ConnStateData *, struct in_addr);
 extern void authenticateAuthUserUnlock(auth_user_t * auth_user);
 extern void authenticateAuthUserLock(auth_user_t * auth_user);
 extern void authenticateAuthUserRequestUnlock(auth_user_request_t *);
 extern void authenticateAuthUserRequestLock(auth_user_request_t *);
 extern char *authenticateAuthUserRequestMessage(auth_user_request_t *);
 extern int authenticateAuthUserInuse(auth_user_t * auth_user);
-extern void authenticateAuthUserRequestRemoveIp(auth_user_request_t *, struct sockaddr *);
+extern void authenticateAuthUserRequestRemoveIp(auth_user_request_t *, struct in_addr);
 extern void authenticateAuthUserRequestClearIp(auth_user_request_t *);
 extern int authenticateAuthUserRequestIPCount(auth_user_request_t *);
 extern int authenticateDirection(auth_user_request_t *);
@@ -812,7 +812,7 @@
 
 /* ident.c */
 #if USE_IDENT
-extern void identStart(struct sockaddr *me, struct sockaddr *my_peer,
+extern void identStart(struct sockaddr_in *me, struct sockaddr_in *my_peer,
     IDCB * callback, void *cbdata);
 extern void identInit(void);
 #endif
@@ -1172,12 +1172,12 @@
 extern ErrorState *errorCon(err_type type, http_status, request_t * request);
 extern int errorPageId(const char *page_name);
 
-extern void pconnPush(int, const char *host, u_short port, const char *domain, struct sockaddr *client_address);
-extern int pconnPop(const char *host, u_short port, const char *domain, struct sockaddr *client_address);
-extern hash_link *pconnLookup(const char *peer, u_short port, const char *domain, struct sockaddr *client_address);
+extern void pconnPush(int, const char *host, u_short port, const char *domain, struct in_addr *client_address, u_short client_port);
+extern int pconnPop(const char *host, u_short port, const char *domain, struct in_addr *client_address, u_short client_port);
+extern hash_link *pconnLookup(const char *peer, u_short port, const char *domain, struct in_addr *client_address, u_short client_port);
 extern void pconnInit(void);
 
-extern int asnMatchIp(void *, struct sockaddr *);
+extern int asnMatchIp(void *, struct in_addr);
 extern void asnInit(void);
 extern void asnFreeMemory(void);
 
@@ -1208,8 +1208,6 @@
 int xusleep(unsigned int usec);
 void keepCapabilities(void);
 
-extern char *sockaddr_ntoa(struct sockaddr_storage *);
-
 #if USE_HTCP
 extern void htcpInit(void);
 extern void htcpQuery(StoreEntry * e, request_t * req, peer * p);
Index: squid/src/redirect.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/redirect.c,v
retrieving revision 1.3.6.6
retrieving revision 1.3.6.7
diff -u -r1.3.6.6 -r1.3.6.7
--- squid/src/redirect.c	1 Jul 2007 05:44:24 -0000	1.3.6.6
+++ squid/src/redirect.c	2 Jul 2007 07:37:02 -0000	1.3.6.7
@@ -1,6 +1,6 @@
 
 /*
- * $Id: redirect.c,v 1.3.6.6 2007/07/01 05:44:24 amosjeffries Exp $
+ * $Id: redirect.c,v 1.3.6.7 2007/07/02 07:37:02 amosjeffries Exp $
  *
  * DEBUG: section 61    Redirector
  * AUTHOR: Duane Wessels
@@ -38,7 +38,7 @@
 typedef struct {
     void *data;
     char *orig_url;
-    struct sockaddr_storage client_addr;
+    struct in_addr client_addr;
     const char *client_ident;
     const char *method_s;
     RH *handler;
@@ -109,7 +109,7 @@
     }
     r = cbdataAlloc(redirectStateData);
     r->orig_url = xstrdup(http->uri);
-    xmemcpy(&r->client_addr, &conn->log_addr, sizeof(struct sockaddr_storage));
+    r->client_addr = conn->log_addr;
     r->client_ident = NULL;
     if (http->request->auth_user_request)
 	r->client_ident = authenticateUserRequestUsername(http->request->auth_user_request);
@@ -128,11 +128,11 @@
     r->handler = handler;
     r->data = data;
     cbdataLock(r->data);
-    if ((fqdn = fqdncache_gethostbyaddr(&r->client_addr, 0)) == NULL)
+    if ((fqdn = fqdncache_gethostbyaddr(r->client_addr, 0)) == NULL)
 	fqdn = dash_str;
     snprintf(buf, 8191, "%s %s/%s %s %s %s",
 	r->orig_url,
-	sockaddr_ntoa(&r->client_addr),
+	inet_ntoa(r->client_addr),
 	fqdn,
 	r->client_ident[0] ? rfc1738_escape(r->client_ident) : dash_str,
 	r->method_s,
Index: squid/src/send-announce.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/send-announce.c,v
retrieving revision 1.3.6.5
retrieving revision 1.3.6.6
diff -u -r1.3.6.5 -r1.3.6.6
--- squid/src/send-announce.c	1 Jul 2007 05:44:24 -0000	1.3.6.5
+++ squid/src/send-announce.c	2 Jul 2007 07:37:02 -0000	1.3.6.6
@@ -1,6 +1,6 @@
 
 /*
- * $Id: send-announce.c,v 1.3.6.5 2007/07/01 05:44:24 amosjeffries Exp $
+ * $Id: send-announce.c,v 1.3.6.6 2007/07/02 07:37:02 amosjeffries Exp $
  *
  * DEBUG: section 27    Cache Announcer
  * AUTHOR: Duane Wessels
@@ -53,7 +53,7 @@
 {
     LOCAL_ARRAY(char, tbuf, 256);
     LOCAL_ARRAY(char, sndbuf, BUFSIZ);
-    struct sockaddr_storage S;
+    struct sockaddr_in S;
     char *host = Config.Announce.host;
     char *file = NULL;
     u_short port = Config.Announce.port;
@@ -96,11 +96,9 @@
 	}
     }
     memset(&S, '\0', sizeof(S));
-    xmemcpy(&S, &ia->in_addrs[0], sizeof(S));
-    if (S.ss_family == AF_INET6)
-        ((struct sockaddr_in6 *)&S)->sin6_port = htons(port);
-    if (S.ss_family == AF_INET)
-        ((struct sockaddr_in *)&S)->sin_port = htons(port);
+    S.sin_family = AF_INET;
+    S.sin_port = htons(port);
+    S.sin_addr = ia->in_addrs[0];
     assert(theOutIcpConnection > 0);
     x = comm_udp_sendto(theOutIcpConnection,
 	&S, sizeof(S),
Index: squid/src/snmp_agent.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/snmp_agent.c,v
retrieving revision 1.3.6.5
retrieving revision 1.3.6.6
diff -u -r1.3.6.5 -r1.3.6.6
--- squid/src/snmp_agent.c	1 Jul 2007 05:44:24 -0000	1.3.6.5
+++ squid/src/snmp_agent.c	2 Jul 2007 07:37:02 -0000	1.3.6.6
@@ -1,6 +1,6 @@
 
 /*
- * $Id: snmp_agent.c,v 1.3.6.5 2007/07/01 05:44:24 amosjeffries Exp $
+ * $Id: snmp_agent.c,v 1.3.6.6 2007/07/02 07:37:02 amosjeffries Exp $
  *
  * DEBUG: section 49     SNMP Interface
  * AUTHOR: Kostas Anagnostakis
@@ -164,7 +164,7 @@
 	laddr = oid2addr(&Var->name[LEN_SQ_MESH + 3]);
 	for (p = Config.peers; p != NULL; p = p->next, cnt++) {
 	    index++;
-	    if (((struct sockaddr_in *)&p->in_addr)->sin_addr.s_addr == laddr->s_addr)
+	    if (p->in_addr.sin_addr.s_addr == laddr->s_addr)
 		break;
 	}
 	break;
@@ -201,7 +201,7 @@
 	break;
     case MESH_PTBL_IP:
 	Answer = snmp_var_new_integer(Var->name, Var->name_length,
-	    (snint) ((struct sockaddr_in *)&p->in_addr)->sin_addr.s_addr,
+	    (snint) p->in_addr.sin_addr.s_addr,
 	    SMI_IPADDRESS);
 	break;
     case MESH_PTBL_HTTP:
Index: squid/src/snmp_core.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/snmp_core.c,v
retrieving revision 1.3.6.9
retrieving revision 1.3.6.10
diff -u -r1.3.6.9 -r1.3.6.10
--- squid/src/snmp_core.c	1 Jul 2007 05:44:24 -0000	1.3.6.9
+++ squid/src/snmp_core.c	2 Jul 2007 07:37:03 -0000	1.3.6.10
@@ -1,6 +1,6 @@
 
 /*
- * $Id: snmp_core.c,v 1.3.6.9 2007/07/01 05:44:24 amosjeffries Exp $
+ * $Id: snmp_core.c,v 1.3.6.10 2007/07/02 07:37:03 amosjeffries Exp $
  *
  * DEBUG: section 49    SNMP support
  * AUTHOR: Glenn Chisholm
@@ -390,21 +390,17 @@
 snmpConnectionOpen(void)
 {
     u_short port;
-    struct sockaddr_storage xaddr;
+    struct sockaddr_in xaddr;
     socklen_t len;
     int x;
 
     debug(49, 5) ("snmpConnectionOpen: Called\n");
     if ((port = Config.Port.snmp) > (u_short) 0) {
 	enter_suid();
-
-	if (Config.Addrs.snmp_incoming.ss_family == AF_INET6)
-	    ((struct sockaddr_in6 *)&Config.Addrs.snmp_incoming)->sin6_port = ntohs(port);
-	else
-	    ((struct sockaddr_in *)&Config.Addrs.snmp_incoming)->sin_port = ntohs(port);
 	theInSnmpConnection = comm_open(SOCK_DGRAM,
 	    IPPROTO_UDP,
-	    &Config.Addrs.snmp_incoming,
+	    Config.Addrs.snmp_incoming,
+	    port,
 	    COMM_NONBLOCKING,
 	    "SNMP Port");
 	leave_suid();
@@ -413,18 +409,12 @@
 	commSetSelect(theInSnmpConnection, COMM_SELECT_READ, snmpHandleUdp, NULL, 0);
 	debug(1, 1) ("Accepting SNMP messages on port %d, FD %d.\n",
 	    (int) port, theInSnmpConnection);
-	if ((Config.Addrs.snmp_outgoing.ss_family == AF_INET6 &&
-	    !IN6_IS_ADDR_ALLF(&(((struct sockaddr_in6 *)&Config.Addrs.snmp_outgoing)->sin6_addr))) ||
-	    (Config.Addrs.snmp_outgoing.ss_family == AF_INET &&
-	    ((struct sockaddr_in *)&Config.Addrs.snmp_outgoing)->sin_addr.s_addr != no_addr.s_addr)) {
+	if (Config.Addrs.snmp_outgoing.s_addr != no_addr.s_addr) {
 	    enter_suid();
-	    if (Config.Addrs.snmp_outgoing.ss_family == AF_INET6)
-		((struct sockaddr_in6 *)&Config.Addrs.snmp_outgoing)->sin6_port = ntohs(port);
-	    else
-		((struct sockaddr_in *)&Config.Addrs.snmp_outgoing)->sin_port = ntohs(port);
 	    theOutSnmpConnection = comm_open(SOCK_DGRAM,
 		IPPROTO_UDP,
-		&Config.Addrs.snmp_outgoing,
+		Config.Addrs.snmp_outgoing,
+		port,
 		COMM_NONBLOCKING,
 		"SNMP Port");
 	    leave_suid();
@@ -441,8 +431,8 @@
 	} else {
 	    theOutSnmpConnection = theInSnmpConnection;
 	}
-	memset(&theOutSNMPAddr, '\0', sizeof(struct sockaddr_storage));
-	len = sizeof(struct sockaddr_storage);
+	memset(&theOutSNMPAddr, '\0', sizeof(struct in_addr));
+	len = sizeof(struct sockaddr_in);
 	memset(&xaddr, '\0', len);
 	x = getsockname(theOutSnmpConnection,
 	    (struct sockaddr *) &xaddr, &len);
@@ -450,7 +440,7 @@
 	    debug(51, 1) ("theOutSnmpConnection FD %d: getsockname: %s\n",
 		theOutSnmpConnection, xstrerror());
 	else
-	    xmemcpy(&theOutSNMPAddr, &xaddr, sizeof(xaddr));
+	    theOutSNMPAddr = xaddr.sin_addr;
     }
 }
 
@@ -500,7 +490,7 @@
 snmpHandleUdp(int sock, void *not_used)
 {
     LOCAL_ARRAY(char, buf, SNMP_REQUEST_SIZE);
-    struct sockaddr_storage from;
+    struct sockaddr_in from;
     socklen_t from_len;
     snmp_request_t *snmp_rq;
     int len;
@@ -508,7 +498,7 @@
     debug(49, 5) ("snmpHandleUdp: Called.\n");
 
     commSetSelect(sock, COMM_SELECT_READ, snmpHandleUdp, NULL, 0);
-    from_len = sizeof(struct sockaddr_storage);
+    from_len = sizeof(struct sockaddr_in);
     memset(&from, '\0', from_len);
     memset(buf, '\0', SNMP_REQUEST_SIZE);
 
@@ -526,14 +516,14 @@
 	debug(49, 3) ("snmpHandleUdp: FD %d: received %d bytes from %s.\n",
 	    sock,
 	    len,
-	    sockaddr_ntoa(&from));
+	    inet_ntoa(from.sin_addr));
 
 	snmp_rq = xcalloc(1, sizeof(snmp_request_t));
 	snmp_rq->buf = (u_char *) buf;
 	snmp_rq->len = len;
 	snmp_rq->sock = sock;
 	snmp_rq->outbuf = xmalloc(snmp_rq->outlen = SNMP_REQUEST_SIZE);
-	xmemcpy(&snmp_rq->from, &from, sizeof(struct sockaddr_storage));
+	xmemcpy(&snmp_rq->from, &from, sizeof(struct sockaddr_in));
 	snmpDecodePacket(snmp_rq);
 	xfree(snmp_rq->outbuf);
 	xfree(snmp_rq);
@@ -561,7 +551,7 @@
     rq->session.Version = SNMP_VERSION_1;
     Community = snmp_parse(&rq->session, PDU, buf, len);
     memset(&checklist, '\0', sizeof(checklist));
-    xmemcpy(&checklist.src_addr, &rq->from, SOCKLEN(&rq->from));
+    checklist.src_addr = rq->from.sin_addr;
     checklist.snmp_community = (char *) Community;
 
     if (Community)
@@ -573,7 +563,7 @@
 	snmpConstructReponse(rq);
     } else {
 	debug(49, 1) ("Failed SNMP agent query from : %s.\n",
-	    sockaddr_ntoa(&rq->from));
+	    inet_ntoa(rq->from.sin_addr));
 	snmp_free_pdu(PDU);
     }
     if (Community)
@@ -593,7 +583,7 @@
     snmp_free_pdu(rq->PDU);
     if (RespPDU != NULL) {
 	snmp_build(&rq->session, RespPDU, rq->outbuf, &rq->outlen);
-	comm_udp_sendto(rq->sock, &rq->from, SOCKLEN(&rq->from), rq->outbuf, rq->outlen);
+	comm_udp_sendto(rq->sock, &rq->from, sizeof(rq->from), rq->outbuf, rq->outlen);
 	snmp_free_pdu(RespPDU);
     }
 }
@@ -827,46 +817,24 @@
     if (peerptr == NULL) {
 	/* Do nothing */
     } else if (*len <= current->len) {
-	if (peerptr->in_addr.ss_family == AF_INET6) 
-	    instance = xmalloc(sizeof(name) * (*len + 16));
-	else
-	    instance = xmalloc(sizeof(name) * (*len + 4));
+	instance = xmalloc(sizeof(name) * (*len + 4));
 	xmemcpy(instance, name, (sizeof(name) * *len));
-	if (peerptr->in_addr.ss_family == AF_INET6) 
-		cp = (u_char *) & (((struct sockaddr_in6 *)&peerptr->in_addr)->sin6_addr.s6_addr);
-	else
-		cp = (u_char *) & (((struct sockaddr_in *)&peerptr->in_addr)->sin_addr.s_addr);
+	cp = (u_char *) & (peerptr->in_addr.sin_addr.s_addr);
 	instance[*len] = *cp++;
 	instance[*len + 1] = *cp++;
 	instance[*len + 2] = *cp++;
 	instance[*len + 3] = *cp++;
-	if (peerptr->in_addr.ss_family == AF_INET6) {
-	    instance[*len + 4] = *cp++;
-	    instance[*len + 5] = *cp++;
-	    instance[*len + 6] = *cp++;
-	    instance[*len + 7] = *cp++;
-	    instance[*len + 8] = *cp++;
-	    instance[*len + 9] = *cp++;
-	    instance[*len + 10] = *cp++;
-	    instance[*len + 11] = *cp++;
-	    instance[*len + 12] = *cp++;
-	    instance[*len + 13] = *cp++;
-	    instance[*len + 14] = *cp++;
-	    instance[*len + 15] = *cp++;
-	    *len += 16;
-	}
-	else
-	    *len += 4;
+	*len += 4;
     } else {
 	laddr = oid2addr(&name[*len - 4]);
 	host_addr = inet_ntoa(*laddr);
 	last_addr = xstrdup(host_addr);
       skip_duplicate:
-	current_addr = sockaddr_ntoa(&peerptr->in_addr);
+	current_addr = inet_ntoa(peerptr->in_addr.sin_addr);
 	while (peerptr && strcmp(last_addr, current_addr) != 0) {
 	    peerptr = peerptr->next;
 	    if (peerptr)
-		current_addr = sockaddr_ntoa(&peerptr->in_addr);
+		current_addr = inet_ntoa(peerptr->in_addr.sin_addr);
 	}
 
 	/* Find the next peer */
@@ -875,7 +843,7 @@
 
 	/* watch out for duplicate addresses */
 	for (peerptr2 = Config.peers; peerptr && peerptr2 != peerptr; peerptr2 = peerptr2->next) {
-	    if (memcmp(&peerptr2->in_addr, &peerptr->in_addr, SOCKLEN(&peerptr->in_addr))) {
+	    if (peerptr2->in_addr.sin_addr.s_addr == peerptr->in_addr.sin_addr.s_addr) {
 		/* ouch.. there are more than one peer on this IP. Skip the second one */
 		peerptr = peerptr->next;
 		if (peerptr)
@@ -888,23 +856,7 @@
 	if (peerptr) {
 	    instance = xmalloc(sizeof(name) * (*len));
 	    xmemcpy(instance, name, (sizeof(name) * *len));
-	    if (peerptr->in_addr.ss_family == AF_INET6)  {
-		cp = (u_char *) & (((struct sockaddr_in6 *)&peerptr->in_addr)->sin6_addr.s6_addr);
-		instance[*len - 16] = *cp++;
-		instance[*len - 15] = *cp++;
-		instance[*len - 14] = *cp++;
-		instance[*len - 13] = *cp++;
-		instance[*len - 12] = *cp++;
-		instance[*len - 11] = *cp++;
-		instance[*len - 10] = *cp++;
-		instance[*len - 9] = *cp++;
-		instance[*len - 8] = *cp++;
-		instance[*len - 7] = *cp++;
-		instance[*len - 6] = *cp++;
-		instance[*len - 5] = *cp++;
-	    }
-	    else 
-		cp = (u_char *) & (((struct sockaddr_in *)&peerptr->in_addr)->sin_addr.s_addr);
+	    cp = (u_char *) & (peerptr->in_addr.sin_addr.s_addr);
 	    instance[*len - 4] = *cp++;
 	    instance[*len - 3] = *cp++;
 	    instance[*len - 2] = *cp++;
